#include <stdio.h>
#include <stdlib.h>

int main (int argc, char **argv) {
	char *qc;
	qc = getenv("QUERY_STRING");
	printf("QUERY_STRING=%s\n", qc);
	if (!qc) return 1;
	for ( ; *qc ; ++qc ) {
		switch ( *qc ) {
			case '%':
				++qc;
				if ( *qc & 1 << 6 ) *qc += 9;
				if ( qc[1] & 1 << 6 ) qc[1] += 9;
				qc[1] = (*qc << 4) | (qc[1] & 0x0f);
				break;
			case '=':
				putchar('=');
				putchar('\'');
				break;
			case '\'':
				printf("'\\''");
				break;
			case '&':
				putchar('\'');
				putchar('\n');
				break;
			default:
				putchar(*qc);
				break;
		}
	}
	putchar('\'');
	return 0;
}

